untyped
global function CSrandInit

void function CSrandInit()
{	#if MP
	AddOnDeathCallback( "player", MainRandomizeFunc )
	//idea: get view player from spectating upon death
	#endif
}

void function MainRandomizeFunc(entity player)
{

	if(player == GetLocalClientPlayer())
	{
		if(GetConVarInt("csrand_mode") == 0)
			return
		else if(GetConVarInt("csrand_mode") == 1)
			FullRandomize()
		else if(GetConVarInt("csrand_mode") == 2)
			RandomizeSlot()
	}

}

void function FullRandomize()
{

	int chosenIndex = GetConVarInt("csrand_index")
	if(chosenIndex < 1 || chosenIndex > 10)
	{
		chosenIndex = 10
	}
	chosenIndex -= 1
	
	//This could be automated, but that would take too much time and i'm lazy
	RandomizeLoadoutPart("suit", chosenIndex, suitNames)
	RandomizeLoadoutPart("ordnance", chosenIndex, GetAllWeaponsByType( [ eItemTypes.PILOT_ORDNANCE ] ))
	
	RandomizeLoadoutPart("primary", chosenIndex, GetAllWeaponsByType( [ eItemTypes.PILOT_PRIMARY ] ))
	RandomizeLoadoutPart("primaryMod1", chosenIndex, allowedweaponmods)
	RandomizeLoadoutPart("primaryMod2", chosenIndex, allowedweaponmods)
	//RandomizeLoadoutPart("primaryMod3", chosenIndex, allowedweaponmods) //the funny
	RandomizeLoadoutPart("primaryAttachment", chosenIndex, allowedattachments)
	
	//secondaries need magic to happen since changing from AT to pistol messes up everything
	//magic:
	if(pistols.find(GetPersistentLoadoutValue( GetLocalClientPlayer(), "pilot", chosenIndex, "secondary" )) == -1)
		{
			GetLocalClientPlayer().ClientCommand( "SwapSecondaryAndWeapon3PersistentLoadoutData " + chosenIndex )
		}
	
	RandomizeLoadoutPart("secondary", chosenIndex, pistols)
	RandomizeLoadoutPart("secondaryMod1", chosenIndex, allowedweaponmods)
	RandomizeLoadoutPart("secondaryMod2", chosenIndex, allowedweaponmods)
	
	RandomizeLoadoutPart("weapon3", chosenIndex, atWeps) //enum won't work
	RandomizeLoadoutPart("weapon3Mod1", chosenIndex, allowedweaponmods)
	RandomizeLoadoutPart("weapon3Mod2", chosenIndex, allowedweaponmods)
	
	//skins
	
	//this is so unnecessary but idk how else to do it, it may cause some funny things happen i hope it doesn't
	array <string> camoIndexes = []
	//string sillyString = ""
	for(int i = 0; i<=160; i++)
	{
		//sillyString = tostring(i)
		camoIndexes.append(i.tostring())
	}
	array <string> skinIndexes = ["1"]
	RandomizeLoadoutPart("camoIndex", chosenIndex, camoIndexes)
	
	RandomizeLoadoutPart("primaryCamoIndex", chosenIndex, camoIndexes)
	RandomizeLoadoutPart("primarySkinIndex", chosenIndex, skinIndexes)
	RandomizeLoadoutPart("secondaryCamoIndex", chosenIndex, camoIndexes)
	RandomizeLoadoutPart("secondarySkinIndex", chosenIndex, skinIndexes)
	RandomizeLoadoutPart("weapon3CamoIndex", chosenIndex, camoIndexes)
	RandomizeLoadoutPart("weapon3SkinIndex", chosenIndex, skinIndexes)
	
	//swap to preferred
	if(GetConVarInt("csrand_ppslot") == 1)
		GetLocalClientPlayer().ClientCommand( "SwapSecondaryAndWeapon3PersistentLoadoutData " + chosenIndex )
	
	RandomizeLoadoutPart("passive1", chosenIndex, passive1Names)
	RandomizeLoadoutPart("passive2", chosenIndex, passive2Names)
	
	//RandomizeLoadoutPart("execution", chosenIndex, GetAllWeaponsByType( [ eItemTypes.PILOT_EXECUTION ] ))
	
	//do the same for titans, might be complicated

}

void function RandomizeLoadoutPart(string partName, int slot, array <string> options) //done
{
	GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + slot + " " + partName + " " + options.getrandom())
}

void function RandomizeSlot() //done
{
	GetLocalClientPlayer().ClientCommand( "RequestPilotLoadout " + availablePilotLoadouts.getrandom() )
	GetLocalClientPlayer().ClientCommand( "InGameMPMenuClosed 1 0" )
	
	if(GetConVarInt("csrand_titans") == 1)
	{
		GetLocalClientPlayer().ClientCommand( "RequestTitanLoadout " + availableTitanLoadouts.getrandom() )
		GetLocalClientPlayer().ClientCommand( "InGameMPMenuClosed 0 1" )
	}
}


//Constants needed for this to work:

//look sh_consts.gnut

array <int> availablePilotLoadouts = [0,1,2,3,4,5,6,7,8,9]
array <int> availableTitanLoadouts = [0,1,2,3,4,5,6]

array<string> allowedweaponmods = ["extended_ammo",
														"silencer",
														"ricochet",
														"quick_charge",
														"tactical_cdr_on_kill",
														"pas_fast_ads",
														"pas_fast_swap",
														"pas_fast_reload",
														"pas_run_and_gun"]
					array<string> allowedattachments = [
														"hcog",
														"redline_sight",
														"aog",
														"holosight",
														"scope_4x",
														"threat_scope",]
					array<string> pistols = ["mp_weapon_autopistol",
											"mp_weapon_semipistol",
											"mp_weapon_wingman"]							
					array<string> specialNames = [
												"mp_ability_cloak",
												"mp_ability_grapple",
												"mp_weapon_deployable_cover",
												"mp_ability_shifter",
												"mp_weapon_grenade_sonar",
												"mp_ability_heal",
												"mp_ability_holopilot"]
					array<string> suitNames = [
												"geist",
												"grapple",
												"heavy",
												"light",
												"medium",
												"nomad",
												"stalker"]
					array<string> passive1Names = ["pas_ordnance_pack",
													"pas_power_cell",
													"pas_fast_embark",
													"pas_fast_health_regen"]
					array<string> passive1ReturnedNames = ["PAS_ORDNANCE_PACK",
													"PAS_POWER_CELL",
													"PAS_FAST_EMBARK",
													"PAS_FAST_HEALTH_REGEN"]
					array<string> passive2Names = ["pas_stealth_movement",
												"pas_wallhang",
												"pas_ads_hover",
												"pas_enemy_death_icons",
												"pas_at_hunter"]	
					array<string> passive2ReturnedNames = ["PAS_STEALTH_MOVEMENT",
												"PAS_WALLHANG",
												"PAS_ADS_HOVER",
												"PAS_ENEMY_DEATH_ICONS",
												"PAS_AT_HUNTER"]
					array<string> atWeps = ["mp_weapon_mgl",
											"mp_weapon_defender",
											"mp_weapon_arc_launcher",
											"mp_weapon_rocket_launcher"]
//array<string> primaryweps = GetAllWeaponsByType( [ eItemTypes.PILOT_PRIMARY ] )
//array<string> secondaryweps = GetAllWeaponsByType( [ eItemTypes.PILOT_SECONDARY ] )
//array<string> ordnances = GetAllWeaponsByType( [ eItemTypes.PILOT_ORDNANCE ] )
//eItemTypes.PILOT_WEAPON3